/* **********************************************************************
 *
 *   LED/SrcEdit is free software as specified in the GNU General public License
 *   listed in the file COPYING or http://www.gnu.org/licenses/gpl.txt
 *
 ********************************************************************** */

#ifndef __OBC__
#include <PalmOS.h>
#include <PalmCompatibility.h>
#endif

#include "LedGlobals.h"
/*
const unsigned long  appFileCreator    = 'LedX';
const unsigned short appVersionNum     = 0x01;
const unsigned short appPrefID         = 0x00;
const unsigned short appPrefVersionNum = 0x01;
*/
char gCurrentFile[dmDBNameLength];
char gFileList[MAX_FILES][dmDBNameLength];
int gFileListCount = 0;
int gCurFile = -1;

ToolbarEntry gToolbar[ToolbarEntries] = {
    { 1 },  //, "1", (FontID)0 },
    { 2 },  //, "2", (FontID)0 },
    { 3 },  //, "3", (FontID)0 },
    { 4 },  //, "4", (FontID)0 },
    { 5 },  //, "5", (FontID)0 },
    { 6 },  //, "6", (FontID)0 },
    { 7 },  //, "7", (FontID)0 },
    { 8 },  //, "8", (FontID)0 },
    { 9 },  //, "9", (FontID)0 },
    { 10 }, //, "10", (FontID)0 },
    { 11 }  /*, "11", (FontID)0 }, **new interface 4/22/2002: these items have been moved to menus or the popup menu**
    { 12, "B",  (FontID)0 },
    { 13, "@",  (FontID)0 },
    { 14, "K",  (FontID)0 },
    { 15, "()", (FontID)0 },
    { 16, "H",  (FontID)0 },
    { 0, " ",   (FontID)0 },
    { 0, " ",   (FontID)0 }*/
};

DBSaveData g_dbSaveData[MAX_SAVED_DB] = {{ "",{0,0,0,0,0,0}, 0 },
                                         { "",{0,0,0,0,0,0}, 0 },
                                         { "",{0,0,0,0,0,0}, 0 },
                                         { "",{0,0,0,0,0,0}, 0 },
                                         { "",{0,0,0,0,0,0}, 0 },
                                         { "",{0,0,0,0,0,0}, 0 },
                                         { "",{0,0,0,0,0,0}, 0 },
                                         { "",{0,0,0,0,0,0}, 0 }};

FontID gCurrentFont;  //  04/24/2002
Boolean gColorMode = false;

// added color/grayscale comments 03/25/02
IndexedColorType ictComments;
IndexedColorType ictKeywords = 0x5F; // Blue for Keywords
IndexedColorType ictCommentsSaved;
IndexedColorType ictKeywordsSaved;
IndexedColorType ictText;
IndexedColorType ictString = 0xDB; // Gray for Strings

Boolean gAutoParen = true;
int gTabWidth = 10;             //was 20
int gTabSpaces = 3;             // #847961 (S061) Add Tab/Spaces option
Boolean gUseTabForTab = true;   // #847961 (S061) Add Tab/Spaces option

int gCommentLines = 20;         // number of lines to try to get a C comment

int gNumCKeywords = 47;
int gNumHTMLKeywords = 408;
int gNumASMKeywords = 121;

int gNumCComments = 0;
int gNumASMComments = 0;
int gNumHTMLComments = 0;

// ----

Keyword *gCKeywords = NULL;
Keyword *gHTMLKeywords = NULL;
Keyword *gASMKeywords = NULL;

CommentInfo *gCComments = NULL;
CommentInfo *gASMComments = NULL;
CommentInfo *gHTMLComments = NULL;

// #846728 (S016) External Keyboard Support
KbSup_SupportedKeyboardType gKbSup_SupportedKeyboard = KbSup_NoKeyboard;
MemHandle gKbSup_KeyboardTableH = NULL;
KbSup_Type *gKbSup_KeyboardTable = NULL;
int gSelectionMadeWith = key_None;

//#define PageWidth 151 *now a variable*
//#define PageHeight 140 *now a variable*
Coord PageWidth = 151;
Coord PageHeight = 143; // 143

RectangleType gClipRect;
RectangleType gFullScreen;

// Alphasmart Dana support
Boolean gIsWideDana = false;

DWord gRomVersion;

//#define FontHeight 11 *now a variable*
//#define FontDescender 2 *now a variable*
// PageHeight / FontHeight;
//#define LinesPerPage 13 *now a variable*
UInt8 FontHeight              = 11;
UInt8 FontDescender           = 2;
UInt8 LinesPerPage            = 13;
UInt8 BlinkingCursorHeight    = 9;
UInt8 BlinkingCursorTopOffset = 1;
FontID oldFont;

UInt8 gHighlightMode = NOMODE;  // #846293 (S046) pick highlight mode based on file extension
Boolean gSetHighlightMode = true; // #846293 (S046) pick highlight mode based on file extension

Boolean gUseHardKeysForScrolling = false; // #846292 (S051) Use hard buttons to scroll
UInt16 hardLeftKey = vchrHard2;  // #846292 (S051) Use hard buttons to scroll
UInt16 hardRightKey = vchrHard3;  // #846292 (S051) Use hard buttons to scroll
UInt16 gOldRepeatDelay = slowestKeyDelayRate;
UInt16 gOldPeriod = slowestKeyPeriodRate;
UInt16 gDoubleTapDelay = slowestKeyPeriodRate;
Boolean gQueueAhead = false;

FontID fntAppCustomBase = (FontID)129;

// how far from the top of the line the cursor begins
//#define BlinkingCursorTopOffset 1 *now a variable*
// the height of the cursor itself (FontHeight - 2)
//#define BlinkingCursorHeight 9 *now a variable*

//#define DocumentWidth 400 *now* a variable
Coord DocumentWidth = 400;

unsigned int screenXOrigin = 0;         // where in the document the page displays
unsigned int screenYOrigin = 0;         // so this reflects the scroll amount
unsigned int screenTopLine = 0;

Handle gSearchTextH = NULL;
Boolean gSearchIgnoreCase = true;
Boolean gSearchFromTop = false;          // (S039) Search From Top

char gBlinkCharacter;                   // the character to the right of the blinking insertion point
Boolean gBlinkDrawn = false;
Boolean gBlinkAllowed = false;
unsigned long gBlinkTime = 0;

FontID gLED_ClosureFont = (FontID)0;
int gClosureCharWidth;

unsigned int startLine;                 // the original insertion point at the start of a penDown
unsigned int startOffset;               //          [ document relative ]
unsigned int startCharacter;            //

Boolean gCompletion = true;
Boolean gAutoIndent = true;
unsigned long gLastPenDown = 0;
unsigned long gLastDoubleTap = 0;

Handle gSysTrapH;
long gSysTrapLength;
char *gSysTrapSource;
//DmOpenRef gAssemblerDB;

SelectionRange gCurrentSelection;

BufferedText *bufferedLineContents = NULL;  // the contents of a page full of text

Handle gFontH;
FontType *gFont;

int gToolbarStart = 0;

UInt8 gGrfComprStoredState; // S033 Restore Grafitti State

//
// offscreen image used for scrolling
//
WinHandle gOffscreenPage = NULL;

char **gFilenameList = NULL;
int gFilenameCount;

ToolbarEntry gSavedToolbar[ToolbarEntries];
int gSelectedButton = -1;

unsigned int gPreKeyboardTxtLen = 0;

